package fr.jussieu.linguist.depLin;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import org.jdom.*;
import java.io.*;
import java.awt.event.*;
import java.net.*;


import javax.swing.text.html.HTMLEditorKit;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class LinearTextPanel extends JPanel
{
    private BorderLayout borderLayout1 = new BorderLayout();
    private JEditorPane sentencesEditorPane = new JEditorPane();
    public File saveFileDefault = new File("phrases.html");
    public Element linearTreeRoot;
    public int sortIndex=2;

    public Font nodePolice;
    public Font wordPolice;

    public MenuSettings menuSettings = new MenuSettings();
    public DepLinFrame depLinFrame;
    public CorrespondencePanel correspondencePanel;
    File currentDir = new File(".");


    String currentParentNodeName;

    HTMLEditorKit kit = new HTMLEditorKit();


    private JScrollPane sentencesScrollPane = new JScrollPane();
     WortMouseListener wortMouseListener = new WortMouseListener();

    public LinearTextPanel()
    {
        try
        {
            jbInit();
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {

      sentencesScrollPane.getViewport().add(sentencesEditorPane, null);

      this.setLayout(borderLayout1);
      this.add(sentencesScrollPane, BorderLayout.CENTER);

      sentencesEditorPane.setEditorKit(kit);
      sentencesEditorPane.setEditable(false);

      sentencesEditorPane.addMouseListener(wortMouseListener);

    }

public void showInBig(String info)
{
      sentencesEditorPane.setText("<i><b><font color='#7D007D' size=+2>" + info + "</font></b></i>");
      sentencesEditorPane.setCaretPosition(0);
}


public void showSentences()
{
 ecrireFichier(linearizeIntoArrayList(),saveFileDefault);
}


ArrayList linearizeIntoArrayList() {

     int nombreLinearTreesATraiter = linearTreeRoot.getChildren().size();
     ArrayList tousLin = new ArrayList(nombreLinearTreesATraiter);

     for (int numberLinEl=0; numberLinEl<nombreLinearTreesATraiter; numberLinEl++)
     {

       Element linearElementActuelle = (Element)((Element) linearTreeRoot.getChildren().get(numberLinEl))
                                                 .getChildren().get(0);

       Integer numberLinElInt = new Integer(numberLinEl+1);
//////////////////////////////////
       ArrayList oneLinEl = linearizeLinearTree(linearElementActuelle);
//////////////////////////////////
       // ici encore oneLinEl=(stringPure, chaineDeCaractres)

       // adds the standard word font all around each line.
//       oneLinEl.set(1,"<font face='"+wordPolice.getName()+"'>"+oneLinEl.get(1) + "</font> ");

       String penaltyValue = linearElementActuelle.getAttributeValue("penalty");

       Integer penalty = new Integer(0);
       if (penaltyValue!=null) penalty =  new Integer(penaltyValue);

       oneLinEl.add(0,numberLinElInt);

       oneLinEl.add(2,penalty);
       // maintenant uneTop=(number, stringPure, penalty, chaineDeCaractres)

       tousLin.add(oneLinEl);

     }


//     sentencesEditorPane.setText("Linearization done. <br>");
//     sentencesEditorPane.updateUI(); sentencesEditorPane.validate();
     System.out.println("Linearization done. topFin: "+nombreLinearTreesATraiter);

     //if (sortResultsCheck.isSelected())
     //System.out.println("hier "+sortBox.getSelectedIndex());

     // *********** sorting
//     sentencesEditorPane.setText("Sorting... <br>");
//     sentencesEditorPane.updateUI(); sentencesEditorPane.validate();
     // index de sortBox indique d'aprs quoi on ordonne.
     ArrayComp monComp = new ArrayComp(sortIndex);

     Collections.sort(tousLin, monComp);

     System.out.println("triage fini");

     return tousLin;
   }



   /**
    * for a given root of a linear tree (eg topology), the function reads off the "word" nodes
    * and gives back two types of information:
    * (pure word string, string with html markup concerning fields,domains, etc.)
    * @param el Element the root element of the tree
    * @return ArrayList the resulting information list of the tree
    * (pure word string, string with html markup concerning fields,domains, etc.)
    */

     ArrayList linearizeLinearTree(Element el) {

//       System.out.println("- "+el.getAttributeValue("name"));

       ArrayList oneLinEl = new ArrayList(4);

       String stringLocal = "";

       String chaineLocalGauche = "\n";
       String chaineLocalDroite = "";
       String chaineLocalMilieu = "";

       currentParentNodeName = el.getParent().getAttributeValue("name");


       if (el.getName().equals("word"))
       {

         if (menuSettings.linearizeWithFields)
          chaineLocalGauche += "<sup><small><font color='#FF9900' face='" +nodePolice.getName()+"'>"
          +currentParentNodeName+"</font></small></sup>";

	 chaineLocalGauche += el.getAttributeValue("name");
	 stringLocal = el.getAttributeValue("name")+" ";

	 //      stringLocal = "<font face='"+depTree.wordPolice.getName()+"'>"+chaineLocalGauche + "</font> ";
//	 stringLocal = wordPolice.getName()+" ";

         if (menuSettings.showCommValue)
          chaineLocalGauche += "<small><font color='#AAAAAA' face='" +nodePolice.getName()+"'><sub>"
          +el.getAttributeValue("comm")+"</sub></font></small> ";



       }

       else {// not word, thus box or field
	 if (el.getName().equals("box") &&  menuSettings.linearizeWithDomains)
	 {
           if (menuSettings.linearizeWithFields)
             chaineLocalGauche += "<sup><small><font color='#FF9900' face='" + nodePolice.getName() + "'>"
                 + currentParentNodeName + "</font></small></sup>";

	   chaineLocalGauche += "<font color='#993366' face='" +nodePolice.getName()+"'>[<small><i>"
		      + el.getAttributeValue("name")
		      + "</i></small></font>";

	   chaineLocalDroite = "<font color='#993366' face='" +nodePolice.getName()+"'>]</font> ";

           if (menuSettings.showCommValue)
      chaineLocalGauche += "<small><font color='#AAAAAA' face='" +nodePolice.getName()+"'><sub>"
      +el.getAttributeValue("comm")+"</sub></font></small> ";




	 }
       }


       Iterator iter = el.getChildren().iterator();
       while (iter.hasNext()) {
	 Element nextEl = (Element)iter.next();

	 ArrayList arrayLocal = linearizeLinearTree(nextEl);
	 chaineLocalMilieu += arrayLocal.get(1);
	 stringLocal += arrayLocal.get(0);
//         	 chaineLocalMilieu += arrayLocal.get(0);
//         	 stringLocal += arrayLocal.get(1);
//	 stringLocal = "<font face='"+wordPolice.getName()+"'>"+stringLocal + "</font> ";

       }
       //&&
       oneLinEl.add(stringLocal);
       oneLinEl.add(chaineLocalGauche+chaineLocalMilieu+chaineLocalDroite);
//       System.out.println("returning 0"+oneLinEl.get(0));
//       System.out.println("returning 1"+oneLinEl.get(1));
       return oneLinEl;

     }






     void ecrireFichier(ArrayList tousLinEls, File fichierResultat) {

//       wortEditPane.setText("Writing results in " + fichierResultat + ". <br>");
//       wortEditPane.updateUI(); wortEditPane.validate();
       int nombreStructuresATraiter = tousLinEls.size();
       int nombreSansDouble = 1;
       int nombreMemeOrdre = 1;
       try
       {

         String beginning = "<html><head><TITLE>Results</TITLE></head>\n<body bgcolor='#FFFFFF'>\n";
         beginning += "<font face='"+wordPolice.getName()+"'>";

	 FileWriter out = new FileWriter(fichierResultat);
	 out.write(beginning);

          //  uneTop=(number, stringPure, penalty, chaineDeCaractres)
         //	 first sentence
         String number = "<font face='"+nodePolice.getName()+"'>"+((ArrayList)tousLinEls.get(0)).get(0)+". ";
	 out.write(number);
	 if (menuSettings.showPenalty)
	   out.write("<font color='#FF0080'>{"+((ArrayList)tousLinEls.get(0)).get(2)+"}</font> ");

	 out.write("</font>"+((ArrayList)tousLinEls.get(0)).get(3) + "<br>\n");

         for (int numberLinEls = 1; numberLinEls < nombreStructuresATraiter; numberLinEls++)
         {

           if (menuSettings.getRidOfDoubles)
           {
             if (
                      ! ( ( (ArrayList) tousLinEls.get(numberLinEls)).get(1)).equals(
                        ( (ArrayList) tousLinEls.get(numberLinEls - 1)).get(1))
                 ) // element is different from predecessor

             {

               number = "<font face='"+nodePolice.getName()+"'>"+((ArrayList)tousLinEls.get(numberLinEls)).get(0)+". ";
               out.write(number);
               if (menuSettings.showPenalty)
                 out.write("<font color='#FF0080'>{" +( (ArrayList) tousLinEls.get(numberLinEls)).get(2) +"}</font> ");

               out.write("</font>"+((ArrayList)tousLinEls.get(numberLinEls)).get(3) + "<br>\n");
               nombreSansDouble = nombreSansDouble + 1;
             }
           }
           else
           {// don't get rid of doubles
             if (sortIndex == 1) { // =alphabetical order
               if (
                   ( (ArrayList) tousLinEls.get(numberLinEls)).get(1).equals(
                   ( (ArrayList) tousLinEls.get(numberLinEls - 1)).get(1))
                   ) {
                 ++nombreMemeOrdre;
               }
               else {
                 String text = "<font color='#3366FF' size=-2 face='" + nodePolice.getName() + "'>";
                 text += "Number of structures with the same word order: ";
                 text += nombreMemeOrdre + "</font><br><hr WIDTH='100%'>";
                 out.write(text);
                 nombreMemeOrdre = 1;
               }
             }
             number = "<font face='" + nodePolice.getName() + "'>" +( (ArrayList) tousLinEls.get(numberLinEls)).get(0) + ". ";
             out.write(number);

	 if (menuSettings.showPenalty)
	   out.write("<font color='#FF0080'>{"+((ArrayList)tousLinEls.get(numberLinEls)).get(2)+"}</font> ");

        out.write("</font><font face='" + wordPolice.getName() + "'>"
                  +((ArrayList)tousLinEls.get(numberLinEls)).get(3) + "</font><br>\n");
	 }



	 }//fin boucle for

	 if ((!menuSettings.getRidOfDoubles) && (sortIndex == 1))
	 {
           String text = "<font color='#3366FF' size=-2 face='" + nodePolice.getName() + "'>";
	   text += "Number of structures with the same word order: ";
	   text += nombreMemeOrdre+"</font><br><hr WIDTH='100%'>";
	   out.write(text);

	 }

	 out.write("</font></body></html>");
	 out.close();
       }
       catch (IOException eeee) {depLinFrame.statusBar.setText("Error writing in "+fichierResultat);}

       System.out.println("sauvegarde finie.");
       sentencesEditorPane.setText("Saving done in file " + fichierResultat + ". <br>");



       if (menuSettings.getRidOfDoubles)
	   {sentencesEditorPane.setText(nombreSansDouble
       + "different sentences found. <br>");}

       if((nombreStructuresATraiter < 1000) || menuSettings.showEvenIfLong)
	 showFile(fichierResultat);
       else
       {sentencesEditorPane.setText("Too many sentences to show. Check the file "
			     + fichierResultat + ". <br>");
       }
       String statusBarText;
       if (nombreStructuresATraiter==1)  statusBarText = "Exactly one structure was found. ";
       else { statusBarText = nombreStructuresATraiter+" structures";
       if (menuSettings.getRidOfDoubles)
	 statusBarText += " and "+nombreSansDouble+" different sentences";
       statusBarText += " were found. ";
       }
       statusBarText += "Results saved in " + saveFileDefault + ".";
       depLinFrame.statusBar.setText(statusBarText);


     }


     void showFile(File fichierToShow) {
       try
       {

	 URL testurl = new URL("file:"+fichierToShow);
	 sentencesEditorPane.read(testurl.openStream(),"file:"+fichierToShow);

       }
       catch (IOException eeee) {depLinFrame.statusBar.setText("Difficulties reading "+fichierToShow);
       System.out.println("Difficulties reading "+fichierToShow);}


     }




     void enregistrerFichierSousAutreNom(ActionEvent e) {

       JFileChooser fc = new JFileChooser();
       fc.setDialogTitle("save as html file");
       fc.setCurrentDirectory(currentDir);
       fc.setSelectedFile(saveFileDefault);
//       fc.showDialog(this,)
        int returnVal = fc.showDialog(this, "Save HTML");


       if (returnVal == 0)
	 ecrireFichier(linearizeIntoArrayList(),fc.getSelectedFile());
     }


     public class ArrayComp implements Comparator {

	 private int sortIndex;

	 public ArrayComp(int sortIndex) {
	   this.sortIndex = sortIndex;
	 }


	 public int compare(Object a, Object b)
	 {
	   //int i
	   if (((ArrayList)a).get(this.sortIndex) instanceof Integer)
	   {

	     Integer aa = (Integer)((ArrayList)a).get(this.sortIndex);
	     Integer bb = (Integer)((ArrayList)b).get(this.sortIndex);
	     return aa.compareTo(bb);
	   }

	   else
	   {
	     String aa = (String)((ArrayList)a).get(this.sortIndex);
	     String bb = (String)((ArrayList)b).get(this.sortIndex);
	     return aa.compareToIgnoreCase(bb);
	   }
	 /*else
	    {
	    Integer aa = (Integer.)((ArrayList)a).get(this.sortIndex);
	    Integer bb = (Integer)((ArrayList)b).get(this.sortIndex);
	    return aa.compareTo(bb);
	    }
	 String aa = (String)((ArrayList)a).get(this.sortIndex);
	 String bb = (String)((ArrayList)b).get(this.sortIndex);


	 return aa.compareTo(bb);*/

	 }



       }



   public  class WortMouseListener extends MouseAdapter
      {

       String from = " ";
       String to = ".";

       public void mouseClicked(MouseEvent e)
       {

	   int caretpos=sentencesEditorPane.getCaretPosition();
	   sentencesEditorPane.selectAll();
	   String untilCaret = sentencesEditorPane.getSelectedText().substring(0,caretpos);

	   sentencesEditorPane.select(caretpos,caretpos);
	   int pointpos = untilCaret.lastIndexOf(to);
	   if(pointpos==-1) return;
	   String untilPoint = untilCaret.substring(0,pointpos);

	   int spacepos = untilPoint.lastIndexOf(from);
	   if(spacepos==-1) return;
	   if(spacepos==1)spacepos++;
	   String numberString = untilPoint.substring(spacepos+1,pointpos);

//	   int number;
	   if (numberString!=null)
	   {
	       try {
		   correspondencePanel.currentOutputNumber = Integer.parseInt(numberString)-1;
		   correspondencePanel.showOutputTree();
	       }
	       catch (Exception ex) {System.out.println("numberproblem");}

	   }
       }

       public void setSearchStrings(String f, String t)
       {
	   from=f;
	   to=t;
       }

   }



}
