package fr.jussieu.linguist.depLin;

import java.awt.*;
import javax.swing.*;
//import com.borland.jbuilder.xml.database.template.XTable;
import java.awt.event.WindowEvent;
//import org.jdom.output.XMLOutputter;
//import java.io.FileOutputStream;
import java.io.*;
import javax.swing.border.TitledBorder;
import org.jdom.Document;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
//import java.beans.PropertyChangeListener;
//import java.beans.PropertyChangeEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2001</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class TopPhonoRulesEditor
    extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  JToolBar jToolBar1 = new JToolBar();
  JEditorPane jEditorPane1 = new JEditorPane();
  Icon questionMark = new ImageIcon(DepLinFrame.class.getResource("question.gif"));
  JButton savebutton = new JButton("Save");
  public JButton saveAsbutton = new JButton();
  JButton exitbutton = new JButton();
  JPanel contentPanel = new JPanel();
   BorderLayout borderLayout2 = new BorderLayout();
   JScrollPane jScrollPane1 = new JScrollPane();
   TitledBorder titledBorder1 = new TitledBorder("");
   TitledBorder titledBorder2 = new TitledBorder("");
  TitledBorder titledBorder3 = new TitledBorder("");
  JLabel statusBar = new JLabel();


  public  boolean grammarChanged = false;
  File grammarFile;
  DepLinPreferences dpl;
  String currFileName = null;  // Full path and filename. null means new/untitled.

  JFileChooser jFileChooser1 = new JFileChooser();
  javax.swing.text.Document document1;
//      = jEditorPane1.getDocument();



  public TopPhonoRulesEditor() {
    try {
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }

  public TopPhonoRulesEditor(Document g, File f, DepLinPreferences preferences) {
      dpl = preferences;
//      grammar = g;
      grammarFile = f;
      currFileName = grammarFile.getAbsolutePath();

      setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
      try {
        jbInit();

        readInFile(f);

      }
      catch(Exception e) {
        e.printStackTrace();

      }
    }




  private void jbInit() throws Exception {

//    titledBorder = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"");
    this.setDefaultCloseOperation(3);
    this.setIconImage((new ImageIcon(DepLinFrame.class.getResource("dl.gif"))).getImage());
    this.setTitle("depLin Topophono Rules Editor");


    getContentPane().setLayout(borderLayout1);
    jMenu1.setText("File");
    jMenuItem1.setText("Exit");
    jEditorPane1.setText("jEditorPane1");

    contentPanel.setLayout(borderLayout2);
    saveAsbutton.setBorder(titledBorder2);

    savebutton.setBorder(titledBorder3);
    statusBar.setText("");
    contentPanel.setMinimumSize(new Dimension(617, 226));
    contentPanel.setPreferredSize(new Dimension(600, 600));

    jMenuBar1.add(jMenu1);
    jMenu1.add(jMenuItem1);
    contentPanel.add(jScrollPane1, java.awt.BorderLayout.CENTER);
    jToolBar1.add(exitbutton);
    jToolBar1.add(saveAsbutton);
    jToolBar1.add(savebutton);
    this.getContentPane().add(contentPanel, java.awt.BorderLayout.CENTER);

    jScrollPane1.getViewport().add(jEditorPane1);
    contentPanel.add(jToolBar1, java.awt.BorderLayout.NORTH);
    contentPanel.add(statusBar, java.awt.BorderLayout.SOUTH);
    savebutton.setEnabled(false);
   savebutton.setFont(new java.awt.Font("Dialog", 0, 12));
   savebutton.setMinimumSize(new Dimension(69, 20));
   savebutton.setPreferredSize(new Dimension(73, 20));

   savebutton.setIcon(new ImageIcon(DepLinRulesEditor.class.getResource("save.gif")));
   savebutton.setMargin(new Insets(2, 2, 2, 2));



   saveAsbutton.setText("Save as...");

   saveAsbutton.setMargin(new Insets(2, 2, 2, 2));
   saveAsbutton.setIcon(new ImageIcon(DepLinRulesEditor.class.getResource("save.gif")));
   saveAsbutton.setPreferredSize(new Dimension(100, 20));
   saveAsbutton.setMinimumSize(new Dimension(69, 20));
    saveAsbutton.setEnabled(true);
   saveAsbutton.setFont(new java.awt.Font("Dialog", 0, 12));

   exitbutton.setText("EXIT");

   exitbutton.setMargin(new Insets(2, 2, 2, 2));
   exitbutton.setPreferredSize(new Dimension(73, 19));
   exitbutton.setToolTipText("");
   exitbutton.setMinimumSize(new Dimension(69, 20));
   exitbutton.setBorder(titledBorder1);
   exitbutton.setFont(new java.awt.Font("Dialog", 0, 12));
   exitbutton.setForeground(Color.red);


   savebutton.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e) {
         saveFile();
       }
    });


    exitbutton.addActionListener(new java.awt.event.ActionListener() {
     public void actionPerformed(ActionEvent e) {
       exit();
     }
   });


  }



  // Open named file; read text from file into jTextArea1; report to statusBar.
  void readInFile(File file) {
    try {
      // Open a file of the given name.


      // Get the size of the opened file.
      int size = (int)file.length();

      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;

      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);

      // Create a character array of the size of the file,
      // to use as a data buffer, into which we will read
      // the text data.
      char[] data = new char[size];

      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }

      in.close();

      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jEditorPane1.setText(new String(data, 0, chars_read));
      document1 = jEditorPane1.getDocument();

      document1.addDocumentListener(new DocumentListener() {
    public void changedUpdate(DocumentEvent e) {
      document1_changedUpdate(e);
    }

    public void insertUpdate(DocumentEvent e) {
      document1_changedUpdate(e);
    }

    public void removeUpdate(DocumentEvent e) {
    }
  });




      // Display the name of the opened directory+file in the statusBar.
      statusBar.setText("Opened "+currFileName);
    }

    catch (IOException e) {
      statusBar.setText("Error opening "+currFileName);
    }
}




  public static void main(String[] args) {

    try {
   UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
 }
 catch(Exception e) {
   e.printStackTrace();
 }
    TopPhonoRulesEditor topphonoruleseditor = new TopPhonoRulesEditor();

 topphonoruleseditor.pack();
 topphonoruleseditor.setSize(new Dimension(650,400));

 topphonoruleseditor.show();


  }

  protected void processWindowEvent(WindowEvent e) {

    if (e.getID() == WindowEvent.WINDOW_CLOSING) {

      exit();

//      super.processWindowEvent(e);
    }
  }

  void exit() {

    //!!
    if(grammarChanged)
      if(saveQuestion()==2) return;
    this.dispose();
  }


  int saveQuestion()
    {
      String announcement="This interesting grammar has not yet been saved and may be lost for ever";
      announcement += "\nDo you want to save it first?";
      int choice = JOptionPane.showConfirmDialog(this, announcement, "Well...",
          JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, questionMark );
      if (choice == 0)
        saveFile();
//        saveGrammar();
      return choice;
  }


  void saveGrammar() {
   try {
//     FileOutputStream outStream = new FileOutputStream(grammarFile);
//
//     //!!
//
//     XMLOutputter out = new XMLOutputter();
//     out.setNewlines(true);
//     out.setTextNormalize(true);
//     out.setIndent("  ");
//     out.output(grammar, outStream);
//     statusBar.setText("Grammar "+grammarFile+" saved.");
//     dpl.addFile("gramm",grammarFile);
//     dpl.writePreferences();
//     grammarChanged=false;
   }
   catch (Exception eee) {
     String text;
     warn(" Can't save grammar under the name of "+grammarFile+"! ");
   eee.printStackTrace();}
 }

 // Save current file; handle not yet having a filename; report to statusBar.
 boolean saveFile() {

   // Handle the case where we don't have a file name yet.
   if (currFileName == null) {
     return saveAsFile();
   }

   try {
     // Open a file of the current name.
     File file = new File (currFileName);

     // Create an output writer that will write to that file.
     // FileWriter handles international characters encoding conversions.
     FileWriter out = new FileWriter(file);
     String text = jEditorPane1.getText();
     out.write(text);
     out.close();
     this.grammarChanged = false;

     // Display the name of the saved directory+file in the statusBar.
     statusBar.setText("Saved to " + currFileName);
     return true;
   }
   catch (IOException e) {
     statusBar.setText("Error saving "+ currFileName);
   }
   return false;
}


 // Save current file, asking user for new destination name.
// Report to statusBar.
 boolean saveAsFile() {
   // Use the SAVE version of the dialog, test return for Approve/Cancel
   if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
     // Set the current file name to the user's selection,
     // then do a regular saveFile
     currFileName = jFileChooser1.getSelectedFile().getPath();
     //repaints menu after item is selected
     this.repaint();
     return saveFile();
   }
   else {
     this.repaint();
     return false;
   }
}



 void warn(String text)
{
 DepLinFrame_WarnBox warn = new DepLinFrame_WarnBox(this,text );
 Dimension dlgSize = warn.getPreferredSize();
 Dimension frmSize = getSize();
 Point loc = getLocation();
 warn.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
 warn.setModal(true);
 warn.show();
}

  public void document1_changedUpdate(DocumentEvent e) {
    grammarChanged=true;
    statusBar.setText("file '"+currFileName+"' has been edited");
    savebutton.setEnabled(true);
  }

}


